 // FREEIMAGE.CH


#xtranslate FREE_IMAGE_FORMAT.FIF_UNKNOWN  => (-1)
#xtranslate FREE_IMAGE_FORMAT.FIF_BMP      => ( 0)
#xtranslate FREE_IMAGE_FORMAT.FIF_ICO      => ( 1)
#xtranslate FREE_IMAGE_FORMAT.FIF_JPEG     => ( 2)
#xtranslate FREE_IMAGE_FORMAT.FIF_JNG      => ( 3)
#xtranslate FREE_IMAGE_FORMAT.FIF_KOALA    => ( 4)
#xtranslate FREE_IMAGE_FORMAT.FIF_LBM      => ( 5)
#xtranslate FREE_IMAGE_FORMAT.FIF_IFF      => ( 5)
#xtranslate FREE_IMAGE_FORMAT.FIF_MNG      => ( 6)
#xtranslate FREE_IMAGE_FORMAT.FIF_PBM      => ( 7)
#xtranslate FREE_IMAGE_FORMAT.FIF_PBMRAW   => ( 8)
#xtranslate FREE_IMAGE_FORMAT.FIF_PCD      => ( 9)
#xtranslate FREE_IMAGE_FORMAT.FIF_PCX      => (10)
#xtranslate FREE_IMAGE_FORMAT.FIF_PGM      => (11)
#xtranslate FREE_IMAGE_FORMAT.FIF_PGMRAW   => (12)
#xtranslate FREE_IMAGE_FORMAT.FIF_PNG      => (13)
#xtranslate FREE_IMAGE_FORMAT.FIF_PPM      => (14)
#xtranslate FREE_IMAGE_FORMAT.FIF_PPMRAW   => (15)
#xtranslate FREE_IMAGE_FORMAT.FIF_RAS      => (16)
#xtranslate FREE_IMAGE_FORMAT.FIF_TARGA    => (17)
#xtranslate FREE_IMAGE_FORMAT.FIF_TIFF     => (18)
#xtranslate FREE_IMAGE_FORMAT.FIF_WBMP     => (19)
#xtranslate FREE_IMAGE_FORMAT.FIF_PSD      => (20)
#xtranslate FREE_IMAGE_FORMAT.FIF_CUT      => (21)
#xtranslate FREE_IMAGE_FORMAT.FIF_XBM      => (22)
#xtranslate FREE_IMAGE_FORMAT.FIF_XPM      => (23)
#xtranslate FREE_IMAGE_FORMAT.FIF_DDS      => (24)
#xtranslate FREE_IMAGE_FORMAT.FIF_GIF      => (25)
#xtranslate FREE_IMAGE_FORMAT.FIF_HDR      => (26)

#xtranslate FREE_IMAGE_TYPE.FIT_UNKNOWN    => ( 0)
#xtranslate FREE_IMAGE_TYPE.FIT_BITMAP     => ( 1)
#xtranslate FREE_IMAGE_TYPE.FIT_UINT16     => ( 2)
#xtranslate FREE_IMAGE_TYPE.FIT_INT16      => ( 3)
#xtranslate FREE_IMAGE_TYPE.FIT_UINT32     => ( 4)
#xtranslate FREE_IMAGE_TYPE.FIT_INT32      => ( 5)
#xtranslate FREE_IMAGE_TYPE.FIT_FLOAT      => ( 6)
#xtranslate FREE_IMAGE_TYPE.FIT_DOUBLE     => ( 7)
#xtranslate FREE_IMAGE_TYPE.FIT_COMPLEX    => ( 8)
#xtranslate FREE_IMAGE_TYPE.FIT_RGB16      => ( 9)
#xtranslate FREE_IMAGE_TYPE.FIT_RGBA16     => (10)
#xtranslate FREE_IMAGE_TYPE.FIT_RGBF       => (11)
#xtranslate FREE_IMAGE_TYPE.FIT_RGBAF      => (12)



// Load / Save flag constants -----------------------------------------------

#define BMP_DEFAULT         0
#define BMP_SAVE_RLE        1
#define CUT_DEFAULT         0
#define DDS_DEFAULT         0
#define FAXG3_DEFAULT	    0
#define GIF_DEFAULT	    0
#define GIF_LOAD256	    1		// Load the image as a 256 color image with ununsed palette entries, if it's 16 or 2 color
#define GIF_PLAYBACK        2		// 'Play' the GIF to generate each frame (as 32bpp) instead of returning raw frame data when loading
#define HDR_DEFAULT	    0
#define ICO_DEFAULT         0
#define ICO_MAKEALPHA	    1		// convert to 32bpp and create an alpha channel from the AND-mask when loading
#define IFF_DEFAULT         0
#define JPEG_DEFAULT        0		// loading (see JPEG_FAST); saving (see JPEG_QUALITYGOOD)
#define JPEG_FAST           0x0001	// load the file as fast as possible, sacrificing some quality
#define JPEG_ACCURATE       0x0002	// load the file with the best quality, sacrificing some speed
#define JPEG_CMYK	    0x0004	// load separated CMYK "as is" (use | to combine with other load flags)
#define JPEG_QUALITYSUPERB  0x80	// save with superb quality (100:1)
#define JPEG_QUALITYGOOD    0x0100	// save with good quality (75:1)
#define JPEG_QUALITYNORMAL  0x0200	// save with normal quality (50:1)
#define JPEG_QUALITYAVERAGE 0x0400	// save with average quality (25:1)
#define JPEG_QUALITYBAD     0x0800	// save with bad quality (10:1)
#define JPEG_PROGRESSIVE    0x2000	// save as a progressive-JPEG (use | to combine with other save flags)
#define KOALA_DEFAULT       0
#define LBM_DEFAULT         0
#define MNG_DEFAULT         0
#define PCD_DEFAULT         0
#define PCD_BASE            1		// load the bitmap sized 768 x 512
#define PCD_BASEDIV4        2		// load the bitmap sized 384 x 256
#define PCD_BASEDIV16       3		// load the bitmap sized 192 x 128
#define PCX_DEFAULT         0
#define PNG_DEFAULT         0
#define PNG_IGNOREGAMMA	    1		// avoid gamma correction
#define PNM_DEFAULT         0
#define PNM_SAVE_RAW        0       // If set the writer saves in RAW format (i.e. P4, P5 or P6)
#define PNM_SAVE_ASCII      1       // If set the writer saves in ASCII format (i.e. P1, P2 or P3)
#define PSD_DEFAULT         0
#define RAS_DEFAULT         0
#define SGI_DEFAULT	    0
#define TARGA_DEFAULT       0
#define TARGA_LOAD_RGB888   1       // If set the loader converts RGB555 and ARGB8888 -> RGB888.
#define TIFF_DEFAULT        0
#define TIFF_CMYK	    0x0001	// reads/stores tags for separated CMYK (use | to combine with compression flags)
#define TIFF_PACKBITS       0x0100  // save using PACKBITS compression
#define TIFF_DEFLATE        0x0200  // save using DEFLATE compression (a.k.a. ZLIB compression)
#define TIFF_ADOBE_DEFLATE  0x0400  // save using ADOBE DEFLATE compression
#define TIFF_NONE           0x0800  // save without any compression
#define TIFF_CCITTFAX3	    0x1000  // save using CCITT Group 3 fax encoding
#define TIFF_CCITTFAX4	    0x2000  // save using CCITT Group 4 fax encoding
#define TIFF_LZW            0x4000	// save using LZW compression
#define TIFF_JPEG           0x8000	// save using JPEG compression
#define WBMP_DEFAULT        0
#define XBM_DEFAULT	    0
#define XPM_DEFAULT	    0

#define FI_RGBA_RED                     2
#define FI_RGBA_GREEN			1
#define FI_RGBA_BLUE			0
#define FI_RGBA_ALPHA			3
#define FI_RGBA_RED_MASK		0x00FF0000
#define FI_RGBA_GREEN_MASK		0x0000FF00
#define FI_RGBA_BLUE_MASK		0x000000FF
#define FI_RGBA_ALPHA_MASK		0xFF000000
#define FI_RGBA_RED_SHIFT		16
#define FI_RGBA_GREEN_SHIFT		8
#define FI_RGBA_BLUE_SHIFT		0
#define FI_RGBA_ALPHA_SHIFT             24

#define FILTER_BOX                     0
#define FILTER_BICUBIC                 1
#define FILTER_BILINEAR                2
#define FILTER_BSPLINE                 3
#define FILTER_CATMULLROM              4
#define FILTER_LANCZOS3                5

#define FICC_RGB                       0
#define FICC_RED                       1
#define FICC_GREEN                     2
#define FICC_BLUE                      3
#define FICC_ALPHA                     4
#define FICC_BLACK                     5
#define FICC_REAL                      6
#define FICC_IMAG                      7
#define FICC_MAG                       8
#define FICC_PHASE                     9

