//------------------------------------------------------------
//  Project: Open Tools for Xbase++                          -
//  Repository : http://www.xbwin.com                        -
//  Author: Pablo Botella Navarro ( http://www.xbwin.com )   -
//------------------------------------------------------------
#ifndef _OT4XB_CH_
#define _OT4XB_CH_
#pragma library ("ot4xb.lib")
// ---------------------------------------------------------------------------
#ifndef CRLF
#define CRLF              (Chr(13)+Chr(10))
#endif
#xcommand DEFAULT <uVar1> := <uVal1> => <uVar1> := iif( <uVar1> == NIL, <uVal1>, <uVar1> )
#xtranslate BYNAME <V> [, <VN> ]     => ::<V> := <V> [; ::<VN> := <VN> ]
#xtranslate BYNAME <V> DEFAULT <Val> => ::<V> := iif(<V> == NIL , <Val> , <V> )
#xtranslate BYNAME <V> IFNONIL =>  if <V> != NIL ; ::<V> := <V> ;  end
// #define MAX(x,y)  ( iif( x > y , x , y) )
// #define MIN(x,y)  ( iif( x < y , x , y) )
#xtranslate StrTrim(<n>)   =>  LTrim(Str(<n>))
//----------------------------------------------------------------------------------------------------------------------
#ifdef OT4XB_DEBUG
#ifndef OT4XB_ASSERT_ALL
#define OT4XB_ASSERT_ALL
#endif
#xtranslate ot4xb_SendFLog(<params,...>) => ot4xb_lSendLogStrFL( __FILE__ , __LINE__ , <params> )
#xtranslate ot4xb_SendLog(<params,...>)  => ot4xb_lSendLogStr( <params> )
#else
#xtranslate ot4xb_SendLog( <params,...>  )  =>
#xtranslate ot4xb_SendFLog( <params,...>  ) =>
#endif                    

//----------------------------------------------------------------------------------------------------------------------
#ifdef OT4XB_ASSERT_ALL
#ifdef OT4XB_ASSERT_LEVEL
#undef OT4XB_ASSERT_LEVEL
#endif
#define OT4XB_ASSERT_LEVEL   100 
#endif
//----------------------------------------------------------------------------------------------------------------------
#ifndef OT4XB_ASSERT_LEVEL
#define OT4XB_ASSERT_LEVEL   0 
#endif
//----------------------------------------------------------------------------------------------------------------------
#if OT4XB_ASSERT_LEVEL > 0
#xtranslate _Assert_Range_(<v>,<min>,<max>) => iif( ((<v> \> <max>) .or. (<v> \< <min>)),;
            ( TlsStackPush(Error():New()) ,TlsStackTop():severity := 2,;
              TlsStackTop():description := "Value out of range" ,;
              Eval(ErrorBlock(),TlsStackPop() ) ),<v>)
#else
#xtranslate _Assert_Range_(<v>,<min>,<max>) => NIL
#endif
//----------------------------------------------------------------------------------------------------------------------
#if OT4XB_ASSERT_LEVEL > 1
#xtranslate _Assert_fp_(<fp>) => iif( <fp> == 0,;
            ( TlsStackPush(Error():New()) ,TlsStackTop():severity := 2,;
              TlsStackTop():description := "Function is not declared" ,;
              Eval(ErrorBlock(),TlsStackPop() )),)
#else
#xtranslate _Assert_fp_(<fp>) => NIL 
#endif
//----------------------------------------------------------------------------------------------------------------------
#if OT4XB_ASSERT_LEVEL > 2
#xtranslate _Assert_dll_fn_(<dll>,<fn>) => iif( nFpGet({<(dll)>,<(fn)>}) == 0,;
            ( TlsStackPush(Error():New()) ,TlsStackTop():severity := 2,;
              TlsStackTop():description := "Function "+<(fn)>+" not found in dll " + <(dll)> ,;
              Eval(ErrorBlock(),TlsStackPop() )),)
#else
#xtranslate _Assert_dll_fn_(<dll>,<fn>) => NIL
#endif
//----------------------------------------------------------------------------------------------------------------------
#define OT4XB_LOG_WND_CLASS  "11CBDBE2_0AF0_4713_B463_269FA6E2654B"
//----------------------------------------------------------------------------------------------------------------------
#define GWST_S_BASE  1
#define GWST_S_EXTRA 2
#define GWST_S_ALL   3
//----------------------------------------------------------------------------------------------------------------------
#xtranslate GwstArrayNext( <o> ) => <o>:_link_( <o>:_addressof_() + <o>:_sizeof_()) 
#xtranslate GwstArrayPrev( <o> ) => <o>:_link_( <o>:_addressof_() + <o>:_sizeof_()) 
//----------------------------------------------------------------------------------------------------------------------
#xtranslate GWSTSKIPBYTES( <n> ) => ooo:_GwstSkipBytes( <n> )
#xtranslate GWSTGETOFFSET() => ooo:_GwstGetOffset()
#xtranslate GWSTSETOFFSET( <n> ) => ooo:_GwstSetOffset( <n> )
#xtranslate GWSTALIGNNEXTMEMBER( <n> ) => ooo:_GwstAlignNextMember( <n> )
#xtranslate GWSTBACK() => ooo:_GwstBack()
#xcommand   GWSTBACK   => GWSTBACK()
#xtranslate GWSTPARENT( [ <p1> ] )  => ooo:_GwstParent( [ <p1>() ] )
#xtranslate ADDGWSTSTYLEMEMBERS() => ooo:AddGwstStyleMembers()
//-----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN DYNAMIC CLASS <Tag> [ FROM <p1> [, <pN>] ] [<*more*>] => ;
          function <Tag>() ;
          ; local ooo ;
          ; local oClass := ClassObject(<(Tag)>);
          [;<more>] ;
          ; if oClass != NIL ;
          ; return oClass ;
          ; end ;
          ; ooo := TXbClass():New( <(Tag)>) ;
          [; ooo:Parent( <p1>() ) ];
          [; ooo:Parent( <pN>() )]
//-----------------------------------------------------------------------------------------------------------------------
#xcommand END DYNAMIC CLASS => oClass := ooo:Create() ; ooo:Destroy() ; return oClass
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC VAR                <cName>  [FLAGS <nExtra> ]    => ooo:_Var(<(cName)> [, <nExtra> ])
#xcommand DYNAMIC CLASS VAR          <cName>  [FLAGS <nExtra> ]    => ooo:_ClassVar(<(cName)> [, <nExtra> ])
#xcommand DYNAMIC SHARED CLASS VAR   <cName>  [FLAGS <nExtra> ]    => ooo:_SharedClassVar(<(cName)> [, <nExtra> ])
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_Property( <(cName)> , <uBlock> )
#xcommand DYNAMIC CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_ClassProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC READONLY PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_ROProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC READONLY CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_ROClassProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC WRITEONLY PROPERTY           <cName>  BLOCK <uBlock>       => ooo:_WOProperty( <(cName)> , <uBlock> )
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY     <cName>  BLOCK <uBlock>       => ooo:_WOClassProperty( <(cName)> , <uBlock> )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  READ <rr> WRITE <ww> => ;
                   ooo:_Property(<(cc)>, {|Self,v|iif( PCount() > 1 , <ww> , <rr> ) } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  READ <rr> WRITE <ww> => ;
                   ooo:_ClassProperty(<(cc)>, {|Self,v|iif( PCount() > 1 , <ww> , <rr> ) } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  READ <rr>  => ;
                   ooo:_ROProperty(<(cc)>, {|Self| <rr>  } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  READ <rr> => ;
                   ooo:_ROClassProperty(<(cc)>, {|Self| <rr> } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC  PROPERTY <cc>  WRITE <ww> => ;
                   ooo:_WOProperty(<(cc)>, {|Self,v| <ww> } )
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  WRITE <ww> => ;
                   ooo:_WOClassProperty(<(cc)>, {|Self,v| <ww> } )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC PROPERTY                  <cName>  COMPILE <ss>  => ooo:_Property( <(cName)> , (&(<ss>))  )
#xcommand DYNAMIC CLASS PROPERTY            <cName>  COMPILE <ss>  => ooo:_ClassProperty( <(cName)> , (&(<ss>)) )
#xcommand DYNAMIC READONLY PROPERTY         <cName>  COMPILE <ss>  => ooo:_ROProperty( <(cName)> ,  (&(<ss>))  )
#xcommand DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE <ss>  => ooo:_ROClassProperty( <(cName)> ,  (&(<ss>)) )
#xcommand DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE <ss>  => ooo:_WOProperty( <(cName)> ,  (&(<ss>))  )
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE <ss>  => ooo:_WOClassProperty( <(cName)> ,  (&(<ss>))  )
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC PROPERTY                  <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC PROPERTY                  <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC CLASS PROPERTY            <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC CLASS PROPERTY            <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC READONLY PROPERTY         <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC READONLY PROPERTY         <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC READONLY CLASS PROPERTY   <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC WRITEONLY PROPERTY        <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
#xcommand DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          DYNAMIC WRITEONLY CLASS PROPERTY  <cName>  COMPILE cPrintf( <(ss)> ,<p1> [,<pN>])
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> => ;
          DYNAMIC  PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> => ;
          DYNAMIC  CLASS PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}"

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr>  => ;
          DYNAMIC  READONLY PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> => ;
          DYNAMIC  READONLY CLASS PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}"

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE WRITE <ww> => ;
          DYNAMIC  WRITEONLY PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}"
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE WRITE <ww> => ;
          DYNAMIC  WRITEONLY CLASS PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}"

//-----------------------------------------------------------------------------------------------------------------------


#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> INSERT <p1> [, <pN>] => ;
          DYNAMIC  PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}" ;
          INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> WRITE <ww> INSERT <p1> [, <pN>] => ;
          DYNAMIC  CLASS PROPERTY <cc>  COMPILE "{|Self,v|iif( PCount() > 1 ," + <ww> +"," +  <rr> +")}" ;
          INSERT <p1> [, <pN>] 

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE READ <rr>  INSERT <p1> [, <pN>]  => ;
          DYNAMIC  READONLY PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}" INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE READ <rr> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  READONLY CLASS PROPERTY <cc>  COMPILE "{|Self|" + <rr> +"}" INSERT <p1> [, <pN>] 

#xcommand DYNAMIC  PROPERTY <cc>  COMPILE WRITE <ww> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  WRITEONLY PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}" INSERT <p1> [, <pN>] 
                   
#xcommand DYNAMIC  CLASS PROPERTY <cc>  COMPILE WRITE <ww> INSERT <p1> [, <pN>]  => ;
          DYNAMIC  WRITEONLY CLASS PROPERTY <cc>  COMPILE "{|Self,v|" + <ww> +"}" INSERT <p1> [, <pN>] 
//-----------------------------------------------------------------------------------------------------------------------

#xcommand DYNAMIC PROPERTY <cc>  IS MASK <mask> OF <var> => ;
          DYNAMIC  PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) ;
          WRITE (  ::<var> := iif(v,nOr( ::<var>,<mask>),nAndNot(::<var>,<mask>)) )

#xcommand DYNAMIC PROPERTY <cc>  IS MASK <mask> OF <var> READONLY => ;
          DYNAMIC  PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) 

#xcommand DYNAMIC PROPERTY <cc>  IS CONSTANT <val> => DYNAMIC  PROPERTY <cc> READ <val>
//----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC CLASS PROPERTY <cc>  IS MASK <mask> OF <var> => ;
          DYNAMIC  CLASS PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) ;
          WRITE (  ::<var> := iif(v,nOr( ::<var>,<mask>),nAndNot(::<var>,<mask>)) )

#xcommand DYNAMIC CLASS PROPERTY <cc>  IS MASK <mask> OF <var> READONLY => ;
          DYNAMIC  CLASS PROPERTY <cc>  ;
          READ lAnd( ::<var> , <mask> ) 

#xcommand DYNAMIC CLASS PROPERTY <cc>  IS CONSTANT <val> => DYNAMIC  CLASS PROPERTY <cc> READ <val>
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DYNAMIC METHOD             <cName>  BLOCK <uBlock>       => ooo:_Method( <(cName)> , <uBlock> )

#xcommand DYNAMIC METHOD <cc>  COMPILE <ss>   => ;
          ooo:_Method( <(cc)> , (&( <(ss)>)) )

#xcommand DYNAMIC METHOD <cc>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          ooo:_Method( <(cc)> , (&( cPrintf( <(ss)> ,<p1> [,<pN>]))) )                                        
          
#xcommand DYNAMIC CLASS METHOD       <cName>  BLOCK <uBlock>       => ooo:_ClassMethod( <(cName)> , <uBlock> )

#xcommand DYNAMIC CLASS METHOD <cc>  COMPILE <ss>   => ;
          ooo:_ClassMethod( <(cc)> , (&( <(ss)>)) )

#xcommand DYNAMIC CLASS METHOD <cc>  COMPILE <ss> INSERT <p1> [, <pN>]  => ;
          ooo:_ClassMethod( <(cc)> , (&( cPrintf( <(ss)> ,<p1> [,<pN>]))) )

//-----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN STRUCTURE <Tag> [EXTENDING <super> ]  [<*more*>] => ;
          BEGIN DYNAMIC CLASS <Tag> [<more>] ;
          ; GWSTPARENT( [ <super> ] )
//-----------------------------------------------------------------------------------------------------------------------
#xcommand END STRUCTURE => END DYNAMIC CLASS
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER @ <cls> <m> => ooo:_Child( <(m)> , <cls>() )
//----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN UNION => ooo:_GwstBeginUnion()
#xcommand END UNION   => ooo:_GwstEndUnion()
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER DWORDNET       <m> => ooo:_Member_DWordNet( <(m)> )
#xcommand MEMBER WORDNET        <m> => ooo:_Member_WordNet( <(m)> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER BOOL           <m> => ooo:_Member_Bool( <(m)> )
#xcommand MEMBER BYTE           <m> => ooo:_Member_Byte( <(m)> )
#xcommand MEMBER U_INT8         <m> => ooo:_Member_Byte( <(m)> )
#xcommand MEMBER WORD           <m> => ooo:_Member_Word( <(m)> )
#xcommand MEMBER INT16          <m> => ooo:_Member_Int16( <(m)> )
#xcommand MEMBER U_INT16        <m> => ooo:_Member_Word( <(m)> )
#xcommand MEMBER SHORT          <m> => ooo:_Member_Short( <(m)> )
#xcommand MEMBER DWORD          <m> => ooo:_Member_DWord( <(m)> )
#xcommand MEMBER S_INT32        <m> => ooo:_Member_DWord( <(m)> )
#xcommand MEMBER ULONG          <m> => ooo:_Member_ULong( <(m)> )
#xcommand MEMBER LONG           <m> => ooo:_Member_Long( <(m)> )
#xcommand MEMBER UINT           <m> => ooo:_Member_UInt( <(m)> )
#xcommand MEMBER INT            <m> => ooo:_Member_Int( <(m)> )
#xcommand MEMBER ENUM           <m> => ooo:_Member_Int( <(m)> )
#xcommand MEMBER INT32          <m> => ooo:_Member_Int32( <(m)> )
#xcommand MEMBER LPARAM         <m> => ooo:_Member_LParam( <(m)> )
#xcommand MEMBER WPARAM         <m> => ooo:_Member_WParam( <(m)> )
#xcommand MEMBER POINTER        <m> => ooo:_Member_Pointer( <(m)> )
#xcommand MEMBER POINTER32      <m> => ooo:_Member_Pointer32( <(m)> )
#xcommand MEMBER HANDLE         <m> => ooo:_Member_Handle( <(m)> )
#xcommand MEMBER HWND           <m> => ooo:_Member_HWND( <(m)> )
#xcommand MEMBER HDC            <m> => ooo:_Member_HDC( <(m)> )
#xcommand MEMBER PCLIPVAR       <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER PXBASEVAR      <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER CODEBLOCK      <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER LPXBASE        <m> => ooo:_Member_Xbase( <(m)> )
#xcommand MEMBER DWORD64        <m> => ooo:_Member_DWord64( <(m)> )
#xcommand MEMBER DOUBLE         <m> => ooo:_Member_Double( <(m)> )
#xcommand MEMBER FLOAT          <m> => ooo:_Member_Float( <(m)> )
#xcommand MEMBER LPSTR          <m> => ooo:_Member_LPSTR( <(m)> )
#xcommand MEMBER DYNSZ          <m> => ooo:_Member_DYNSZ( <(m)> )
#xcommand MEMBER XDATE          <m> => ooo:_Member_XDate( <(m)> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER S_INT8       <m> => ooo:_Member_SINT8( <(m)> )
#xcommand MEMBER S_INT16      <m> => ooo:_Member_SINT16( <(m)> )
#xcommand MEMBER U_INT32      <m> => ooo:_Member_UINT32( <(m)> )
#xcommand MEMBER N_INT64      <m> => ooo:_Member_NINT64( <(m)> )
#xcommand MEMBER BYTEBOOL     <m> => ooo:_Member_ByteBool( <(m)> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER LPSTR  <m> DYNSZ <m2> => MEMBER LPSTR <m> ;
                                          ; GWSTBACK() ; 
                                          ; MEMBER DYNSZ <m2>
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER DYNSZ  <m2> LPSTR <m> => MEMBER LPSTR <m> ;
                                          ; GWSTBACK() ; 
                                          ; MEMBER DYNSZ <m2>
//----------------------------------------------------------------------------------------------------------------------
#xcommand MEMBER BINSTR  <m>  SIZE <n> => ooo:_Member_BINSTR( <(m)> , <n>)
#xcommand MEMBER SZSTR   <m>  SIZE <n> => ooo:_Member_SZSTR( <(m)> , <n>)
#xcommand MEMBER SZWSTR  <m>  SIZE <n> => ooo:_Member_SZWSTR( <(m)> , <n>)
//----------------------------------------------------------------------------------------------------------------------
#xcommand DELEGATE <v> METHOD <cm> WITH PARAMLIST;
          =>; 
          INLINE METHOD <cm>() ;
          ; local n;
          ; local np := PCount();
          ; local ap := Array(np);
          ; local xr := NIL;
          ; for n := 1 to np ;
          ;    ap\[n\] := PValue(n);
          ; next;
          ; if lCallMethodPA(::<v>,<(cm)>,ap,@xr);
          ;    for n := 1 to np ;
          ;       PValue(n,ap\[n\]) ;
          ;    next ;
          ; end;
          ; return xr
//----------------------------------------------------------------------------------------------------------------------
#xcommand DELEGATE <v> METHOD <cm>( [<p1>] [,<pn>] );
          =>; 
          INLINE METHOD <cm>( [<p1>] [,<pn>] ) ;
          ; return ::<v>:<cm>( [@<p1>] [,@<pn>] )
//----------------------------------------------------------------------------------------------------------------------
#xcommand DELEGATE <v> VAR <cm>
          =>; 
          INLINE ACCESS ASSIGN METHOD <cm>(v) ;
          ; if( PCount() > 0);
          ;    return ::<v>:<cm> := v ;
          ; end;
          ; return ::<v>:<cm>
//----------------------------------------------------------------------------------------------------------------------
#xcommand DELEGATE <v> VAR <cm> READONLY
          =>; 
          INLINE ACCESS METHOD <cm>() ;
          ; return ::<v>:<cm>
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
#define MAKEINTRESOURCE(n)    ( nAnd(n,0xFFFF) )
#define MAKEINTATOM(n)        ( nAnd(n,0xFFFF) )
//----------------------------------------------------------------------------------------------------------------------
// Constants for nGetDriveType()
#ifndef ___GETDRIVETYPE___
#define ___GETDRIVETYPE___
#define DRIVE_UNKNOWN     0
#define DRIVE_NO_ROOT_DIR 1
#define DRIVE_REMOVABLE   2
#define DRIVE_FIXED       3
#define DRIVE_REMOTE      4
#define DRIVE_CDROM       5
#define DRIVE_RAMDISK     6
#endif
//----------------------------------------------------------------------------------------------------------------------
#define CREATE_NEW                                1
#define CREATE_ALWAYS                             2
#define OPEN_EXISTING                             3
#define OPEN_ALWAYS                               4
#define TRUNCATE_EXISTING                         5
// ---------------------------------------------------------------------------
#define FILE_SHARE_READ                     0x00000001  
#define FILE_SHARE_WRITE                    0x00000002  
#define FILE_SHARE_DELETE                   0x00000004  
#define FILE_ATTRIBUTE_READONLY             0x00000001  
#define FILE_ATTRIBUTE_HIDDEN               0x00000002  
#define FILE_ATTRIBUTE_SYSTEM               0x00000004  
#define FILE_ATTRIBUTE_DIRECTORY            0x00000010  
#define FILE_ATTRIBUTE_ARCHIVE              0x00000020  
#define FILE_ATTRIBUTE_DEVICE               0x00000040  
#define FILE_ATTRIBUTE_NORMAL               0x00000080  
#define FILE_ATTRIBUTE_TEMPORARY            0x00000100  
#define FILE_ATTRIBUTE_SPARSE_FILE          0x00000200  
#define FILE_ATTRIBUTE_REPARSE_POINT        0x00000400  
#define FILE_ATTRIBUTE_COMPRESSED           0x00000800  
#define FILE_ATTRIBUTE_OFFLINE              0x00001000  
#define FILE_ATTRIBUTE_NOT_CONTENT_INDEXED  0x00002000  
#define FILE_ATTRIBUTE_ENCRYPTED            0x00004000  
#define FILE_NOTIFY_CHANGE_FILE_NAME        0x00000001   
#define FILE_NOTIFY_CHANGE_DIR_NAME         0x00000002   
#define FILE_NOTIFY_CHANGE_ATTRIBUTES       0x00000004   
#define FILE_NOTIFY_CHANGE_SIZE             0x00000008   
#define FILE_NOTIFY_CHANGE_LAST_WRITE       0x00000010   
#define FILE_NOTIFY_CHANGE_LAST_ACCESS      0x00000020   
#define FILE_NOTIFY_CHANGE_CREATION         0x00000040   
#define FILE_NOTIFY_CHANGE_SECURITY         0x00000100   
#define FILE_ACTION_ADDED                   0x00000001   
#define FILE_ACTION_REMOVED                 0x00000002   
#define FILE_ACTION_MODIFIED                0x00000003   
#define FILE_ACTION_RENAMED_OLD_NAME        0x00000004   
#define FILE_ACTION_RENAMED_NEW_NAME        0x00000005   
#define MAILSLOT_NO_MESSAGE                 dwminus(1)
#define MAILSLOT_WAIT_FOREVER               dwminus(1) 
#define FILE_CASE_SENSITIVE_SEARCH          0x00000001  
#define FILE_CASE_PRESERVED_NAMES           0x00000002  
#define FILE_UNICODE_ON_DISK                0x00000004  
#define FILE_PERSISTENT_ACLS                0x00000008  
#define FILE_FILE_COMPRESSION               0x00000010  
#define FILE_VOLUME_QUOTAS                  0x00000020  
#define FILE_SUPPORTS_SPARSE_FILES          0x00000040  
#define FILE_SUPPORTS_REPARSE_POINTS        0x00000080  
#define FILE_SUPPORTS_REMOTE_STORAGE        0x00000100  
#define FILE_VOLUME_IS_COMPRESSED           0x00008000  
#define FILE_SUPPORTS_OBJECT_IDS            0x00010000  
#define FILE_SUPPORTS_ENCRYPTION            0x00020000  
#define FILE_NAMED_STREAMS                  0x00040000  
#define FILE_READ_ONLY_VOLUME               0x00080000  
// ---------------------------------------------------------------------------

#define FILE_READ_DATA            ( 0x0001 )    // file & pipe
#define FILE_LIST_DIRECTORY       ( 0x0001 )    // directory
#define FILE_WRITE_DATA           ( 0x0002 )    // file & pipe
#define FILE_ADD_FILE             ( 0x0002 )    // directory
#define FILE_APPEND_DATA          ( 0x0004 )    // file
#define FILE_ADD_SUBDIRECTORY     ( 0x0004 )    // directory
#define FILE_CREATE_PIPE_INSTANCE ( 0x0004 )    // named pipe
#define FILE_READ_EA              ( 0x0008 )    // file & directory
#define FILE_WRITE_EA             ( 0x0010 )    // file & directory
#define FILE_EXECUTE              ( 0x0020 )    // file
#define FILE_TRAVERSE             ( 0x0020 )    // directory
#define FILE_DELETE_CHILD         ( 0x0040 )    // directory
#define FILE_READ_ATTRIBUTES      ( 0x0080 )    // all
#define FILE_WRITE_ATTRIBUTES     ( 0x0100 )    // all
// ---------------------------------------------------------------------------
#define WinNT_h_DELETE         (0x010000)
#define WinNT_h_READ_CONTROL   (0x020000)
#define WinNT_h_WRITE_DAC      (0x040000)
#define WinNT_h_WRITE_OWNER    (0x080000)
#define WinNT_h_SYNCHRONIZE    (0x100000)
// ---------------------------------------------------------------------------
#define STANDARD_RIGHTS_READ             WinNT_h_READ_CONTROL
#define STANDARD_RIGHTS_WRITE            WinNT_h_READ_CONTROL
#define STANDARD_RIGHTS_EXECUTE          WinNT_h_READ_CONTROL
#define STANDARD_RIGHTS_REQUIRED         dwfix(0x000F,0x0000)
#define STANDARD_RIGHTS_ALL              dwfix(0x001F,0x0000)
#define SPECIFIC_RIGHTS_ALL              dwfix(0x0000,0xFFFF)
#define ACCESS_SYSTEM_SECURITY           dwfix(0x0100,0x0000)
#define MAXIMUM_ALLOWED                  dwfix(0x0200,0x0000)
#define GENERIC_READ                     dwfix(0x8000,0x0000)
#define GENERIC_WRITE                    dwfix(0x4000,0x0000)
#define GENERIC_EXECUTE                  dwfix(0x2000,0x0000)
#define GENERIC_ALL                      dwfix(0x1000,0x0000)
// ---------------------------------------------------------------------------
#define FILE_ALL_ACCESS      nOr(STANDARD_RIGHTS_REQUIRED , WinNT_h_SYNCHRONIZE , 0x1FF)
#define FILE_GENERIC_READ    nOr(STANDARD_RIGHTS_READ,FILE_READ_DATA,FILE_READ_ATTRIBUTES,FILE_READ_EA,WinNT_h_SYNCHRONIZE)
#define FILE_GENERIC_WRITE   nOr(STANDARD_RIGHTS_WRITE,FILE_WRITE_DATA,FILE_WRITE_ATTRIBUTES,FILE_WRITE_EA,FILE_APPEND_DATA,WinNT_h_SYNCHRONIZE)
#define FILE_GENERIC_EXECUTE nOr(STANDARD_RIGHTS_EXECUTE,FILE_READ_ATTRIBUTES,FILE_EXECUTE,WinNT_h_SYNCHRONIZE)

//----------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS MASK <mask> OF <var> => ;
          INLINE ACCESS ASSIGN METHOD <name>(bOnOff) ;
          ; if( PCount() > 0 ) ;
          ;   if( bOnOff ) ;
          ;      ::<var> := nOr( ::<var> , <mask> ) ;
          ;   else ;
          ;      ::<var> := nAndNot( ::<var> , <mask> )  ;
          ;   end ;
          ;   return bOnOff ;
          ;end ;
          ;return lAnd( ::<var> , <mask> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS MASK <mask> OF <var> READONLY => ;
          INLINE ACCESS METHOD <name>() ;
          ;return lAnd( ::<var> , <mask> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand PROPERTY <name>  IS CONSTANT <val> => ;
          INLINE ACCESS METHOD <name>() ;
          ; return <val>
//----------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS MASK <mask> OF <var> => ;
          INLINE ACCESS ASSIGN CLASS METHOD <name>(bOnOff) ;
          ; if( PCount() > 0 ) ;
          ;   if( bOnOff ) ;
          ;      ::<var> := nOr( ::<var> , <mask> ) ;
          ;   else ;
          ;      ::<var> := nAndNot( ::<var> , <mask> )  ;
          ;   end ;
          ;   return bOnOff ;
          ;end ;
          ;return lAnd( ::<var> , <mask> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS MASK <mask> OF <var> READONLY => ;
          INLINE ACCESS CLASS METHOD <name>() ;
          ;return lAnd( ::<var> , <mask> )
//----------------------------------------------------------------------------------------------------------------------
#xcommand CLASS PROPERTY <name>  IS CONSTANT <val> => ;
          INLINE ACCESS CLASS METHOD <name>() ;
          ; return <val>
//----------------------------------------------------------------------------------------------------------------------
#xcommand BEGIN VARLEN STRUCTURE   <cn> => ;
          BEGIN STRUCTURE <cn> local _cgb_ , _cpb_ ;
          ; _cgb_ := "{|s|s:_read_() " ;
          ; _cpb_ := "{|s,v,nn| nn := %u,s:_write_(v,0,nn),"


#xcommand END VARLEN STRUCTURE => ;
            _cgb_ += "}" ;
          ; _cpb_ += "s}" ;
          ; DYNAMIC METHOD Get COMPILE _cgb_ ;
          ; DYNAMIC METHOD Put COMPILE _cpb_ INSERT ooo:GwstGetOffset() ;
          ; END STRUCTURE

#xcommand VARLEN EXTRA MEMBER <cc> SIZE TO <sz> =>  ;
            DYNAMIC  VAR   __<cc> ;
          ; DYNAMIC  PROPERTY <cc> ;
                     READ iif(::__<cc> == NIL,"", ::__<cc>) ;
                     WRITE ( ::<sz> := Len(v) , ::__<cc> := v ) ;
          ; _cgb_ += " + s:" + <(cc)> ;
          ; _cpb_ += "s:__" + <(cc)> + " := PeekStr(@v,@nn,s:" + <(sz)> + "),"

//-----------------------------------------------------------------------------------------------------------------------
#xtranslate AS VOID                    => AS QTYPE "__vo"   
#xtranslate AS BOOL                    => AS QTYPE "__bo"   
#xtranslate AS INT8                    => AS QTYPE "__sc"   
#xtranslate AS CHAR                    => AS INT8
#xtranslate AS BYTE                    => AS QTYPE "__uc"   
#xtranslate AS INT16                   => AS QTYPE "__ss"   
#xtranslate AS SHORT                   => AS INT16
#xtranslate AS WORD                    => AS QTYPE "__us"   
#xtranslate AS INT32                   => AS QTYPE "__sl"   
#xtranslate AS INT                     => AS INT32
#xtranslate AS LONG                    => AS INT32
#xtranslate AS HANDLE                  => AS INT32
#xtranslate AS DWORD                   => AS QTYPE "__ul"   
#xtranslate AS ULONG                   => AS DWORD
#xtranslate AS UINT                    => AS DWORD
#xtranslate AS INT64                   => AS QTYPE "__sq"   
#xtranslate AS QWORD                   => AS QTYPE "__uq"   
#xtranslate AS FLOAT                   => AS QTYPE "__f4"   
#xtranslate AS DOUBLE                  => AS QTYPE "__f8"   
#xtranslate AS POINTER                 => AS QTYPE "__pt"   
#xtranslate AS POINTER32               => AS POINTER
#xtranslate AS LPSTR                   => AS POINTER
#xtranslate AS LPBYTE                  => AS POINTER
#xtranslate AS LPVOID                  => AS POINTER
#xtranslate AS LPBOOL                  => AS QTYPE "_@bo"   
#xtranslate AS LPINT8                  => AS QTYPE "_@sc"   
#xtranslate AS LPCHAR                  => AS LPINT8
#xtranslate AS LPUINT8                 => AS QTYPE "_@uc"   
#xtranslate AS LPINT16                 => AS QTYPE "_@ss"   
#xtranslate AS LPSHORT                 => AS LPINT16
#xtranslate AS LPWORD                  => AS QTYPE "_@us"   
#xtranslate AS LPINT32                 => AS QTYPE "_@sl"   
#xtranslate AS LPLONG                  => AS LPINT32
#xtranslate AS LPDWORD                 => AS QTYPE "_@ul"   
#xtranslate AS LPINT64                 => AS QTYPE "_@sq"   
#xtranslate AS LPQWORD                 => AS QTYPE "_@uq"   
#xtranslate AS LPFLOAT                 => AS QTYPE "_@f4"   
#xtranslate AS LPDOUBLE                => AS QTYPE "_@f8"   
#xtranslate AS STR2WIDE                => AS QTYPE "c_sw"   
#xtranslate AS STR2WIDE_W              => AS QTYPE "c@sw"   
#xtranslate AS ZSTRING                 => AS QTYPE "c_sz"   
#xtranslate AS HWND                    => AS QTYPE "__hw"   
//----------------------------------------------------------------------------------------------------------------------
#xtranslate AS WPARAM  => AS LONG
#xtranslate AS LPARAM  => AS LONG
#xtranslate AS LRESULT => AS LONG
//-----------------------------------------------------------------------------------------------------------------------
#xcommand DLL <cDll> IMPORT <fn> AS QTYPE <rt> ;
                     [  PARAM <p1> AS QTYPE <t1> ]  ;
                     [, PARAM <pN> AS QTYPE <tN> ]  ;
                     [SYMBOL <cfn>]  ;
                     [DEFAULT  <pp1> := <d1> ] ;
                     [,DEFAULT <ppN> := <dN> ] ;
                     => ;
function <fn>( [<p1>] [,<pN>] ) ;
;local _fp_ := nGetProcAddress( <(cDll)> , iif(<.cfn.>,<(cfn)>,<(fn)>) ) ;
[; DEFAULT <pp1> := <d1> ] ;
[; DEFAULT <ppN> := <dN> ] ;
; return ( _Assert_fp_( _fp_ ) , FpQCall( _fp_  ,<rt> [+ <t1>] [+ <tN>] [,@<p1>][,@<pN>]  ) )
//----------------------------------------------------------------------------------------------------------------------
#xcommand STATIC DLL <cDll> IMPORT <fn> AS QTYPE <rt> ;
                        [  PARAM <p1> AS QTYPE <t1> ]  ;
                        [, PARAM <pN> AS QTYPE <tN> ]  ;
                        [SYMBOL <cfn>]  ;
                     [DEFAULT  <pp1> := <d1> ] ;
                     [,DEFAULT <ppN> := <dN> ] ;
                     => ;
static function <fn>( [<p1>] [,<pN>] ) ;
;local _fp_ := nGetProcAddress( <(cDll)> , iif(<.cfn.>,<(cfn)>,<(fn)>) ) ;
[; DEFAULT <pp1> := <d1> ] ;
[; DEFAULT <ppN> := <dN> ] ;
; return ( _Assert_fp_( _fp_ ) , FpQCall( _fp_  ,<rt> [+ <t1>] [+ <tN>] [,@<p1>][,@<pN>]  ) )
//----------------------------------------------------------------------------------------------------------------------
#xcommand DLL <cDll> XIMPORT <fn> AS QTYPE <rt> ;
                     [  PARAM <p1> AS QTYPE <t1> ]  ;
                     [, PARAM <pN> AS QTYPE <tN> ]  ;
                     [SYMBOL <cfn>]     ;
                     [DEFAULT  <pp1> := <d1> ] ;
                     [,DEFAULT <ppN> := <dN> ] ;
                     => ;
function <fn>( [<p1>] [,<pN>] ) ;
; static _fp_ := NIL;
; static _ft_ := NIL;
;if _fp_ == NIL  ;
;   _ft_ := <rt> [+ <t1>] [+ <tN>] ;
;   _fp_ := nGetProcAddress( <(cDll)> , iif(<.cfn.>,<(cfn)>,<(fn)>) ) ;
;end ;
[; DEFAULT <pp1> := <d1> ] ;
[; DEFAULT <ppN> := <dN> ] ;
; return ( _Assert_fp_( _fp_ ) , FpQCall( _fp_  ,<rt> [+ <t1>] [+ <tN>] [,@<p1>][,@<pN>]  ) )
//----------------------------------------------------------------------------------------------------------------------
#xcommand STATIC DLL <cDll> XIMPORT <fn> AS QTYPE <rt> ;
                        [  PARAM <p1> AS QTYPE <t1> ]  ;
                        [, PARAM <pN> AS QTYPE <tN> ]  ;
                        [SYMBOL <cfn>]    ;
                     [DEFAULT  <pp1> := <d1> ] ;
                     [,DEFAULT <ppN> := <dN> ] ;
                     => ;
static function <fn>( [<p1>] [,<pN>] ) ;
; static _fp_ := NIL;
; static _ft_ := NIL;
;if _fp_ == NIL   ;
;   _ft_ := <rt> [+ <t1>] [+ <tN>] ;
;   _fp_ := nGetProcAddress( <(cDll)> , iif(<.cfn.>,<(cfn)>,<(fn)>) ) ;
;end ;
[; DEFAULT <pp1> := <d1> ] ;
[; DEFAULT <ppN> := <dN> ] ;
; return ( _Assert_fp_( _fp_ ) , FpQCall( _fp_  ,<rt> [+ <t1>] [+ <tN>] [,@<p1>][,@<pN>]  ) )
//----------------------------------------------------------------------------------------------------------------------
#xcommand QTEMPLATE <qt> AS QTYPE <rt> [  PARAM AS QTYPE <t1> ]  [, PARAM AS QTYPE <tN> ]  => ;
; <qt> := <rt> [+ <t1>] [+ <tN>]
//----------------------------------------------------------------------------------------------------------------------
#xcommand local QTEMPLATE <qt> AS QTYPE <rt> [  PARAM AS QTYPE <t1> ]  [, PARAM AS QTYPE <tN> ]  => ;
; local <qt> := <rt> [+ <t1>] [+ <tN>]
//----------------------------------------------------------------------------------------------------------------------
#xcommand static QTEMPLATE <qt> AS QTYPE <rt> [  PARAM AS QTYPE <t1> ]  [, PARAM AS QTYPE <tN> ]  => ;
; static <qt> := <rt> [+ <t1>] [+ <tN>]                                                    
//----------------------------------------------------------------------------------------------------------------------
#xtranslate DLL <cDll> IMPORT <rt> <fn>( [<t1> <p1> ] [,<tN> <pN> ] ) ;
                     [<*more*>]  ;
                     => ;
DLL <cDll> IMPORT <fn> AS <rt> ;
                     [  PARAM <p1> AS <t1> ]  ;
                     [, PARAM <pN> AS <tN> ]  ;
                     <more>
//----------------------------------------------------------------------------------------------------------------------
#xtranslate DLL <cDll> XIMPORT <rt> <fn>( [<t1> <p1> ] [,<tN> <pN> ] ) ;
                     [<*more*>]  ;
                     => ;
DLL <cDll> XIMPORT <fn> AS <rt> ;
                     [  PARAM <p1> AS <t1> ]  ;
                     [, PARAM <pN> AS <tN> ]  ;
                     <more>
//----------------------------------------------------------------------------------------------------------------------
#if OT4XB_ASSERT_LEVEL > 2
#xtranslate @<dll>:<fn>([<p1>] [,<pn>] ) => ( _Assert_dll_fn_(<(dll)>,<(fn)>) , nFpCall( {<(dll)>,<(fn)>} [,<p1>] [,<pn>] ) )
#else
#xtranslate @<dll>:<fn>([<p1>] [,<pn>] ) => nFpCall( {<(dll)>,<(fn)>} [,<p1>] [,<pn>] )
#endif
//----------------------------------------------------------------------------------------------------------------------
#xtranslate MEMBER BINSTR <s> DWORD ARRAY <m> ITEMS <n> => ;
            ooo:_Member_BINSTR( <(s)> , <n> * 4 ) ;
            ; ooo:_Method( <(m)> , {|s,n,v| _Assert_Range_(n,0,(<n>-1)),   s:_lock_() , iif( PCount() > 2,;
                                            PokeDWord(s:_addressof_(<(s)>), n * 4,v),;
                                            v := PeekDWord(s:_addressof_(<(s)>), n * 4)),;
                                            s:_unlock_() , v } )
//----------------------------------------------------------------------------------------------------------------------
#xtranslate MEMBER BINSTR <s> WORD ARRAY <m> ITEMS <n> => ;
            ooo:_Member_BINSTR( <(s)> , <n> * 2 ) ;
            ; ooo:_Method( <(m)> , {|s,n,v| _Assert_Range_(n,0,(<n>-1)),   s:_lock_() , iif( PCount() > 2,;
                                            PokeWord(s:_addressof_(<(s)>), n * 2,v),;
                                            v := PeekWord(s:_addressof_(<(s)>), n * 2)),;
                                            s:_unlock_() , v } )
//----------------------------------------------------------------------------------------------------------------------
#xtranslate MEMBER BINSTR <s> BYTE ARRAY <m> ITEMS <n> => ;
            ooo:_Member_BINSTR( <(s)> , <n>   ) ;
            ; ooo:_Method( <(m)> , {|s,n,v| _Assert_Range_(n,0,(<n>-1)),   s:_lock_() , iif( PCount() > 2,;
                                            PokeWord(s:_addressof_(<(s)>), n ,v),;
                                            v := PeekWord(s:_addressof_(<(s)>), n )),;
                                            s:_unlock_() , v } )
//----------------------------------------------------------------------------------------------------------------------
#xcommand WITH OBJECT <o> => WithObjectStackPush(<o>)
#xcommand END WITH => WithObjectStackPop()
#xtranslate .:<*more*> => WithObjectStackTop():<more>
#xtranslate ..:<*more*> => WithObjectStackTop(1):<more>
#xtranslate ...:<*more*> => WithObjectStackTop(2):<more>
#xtranslate ....:<*more*> => WithObjectStackTop(3):<more>
#xtranslate .:(<n>):<*more*> => WithObjectStackTop(<n>):<more>
//----------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------
#endif // _OT4XB_CH_