#INCLUDE 'Freeimage.ch'

#PRAGMA LIBRARY( "ot4xb.LIB" )

//-----------------------------------------------------------------------------
function main()
local dib, bOk ,nDll , nClone ,nRot  ,  nCenterx   , nCentery  , nD1 , nD2
local  nWidth , nHeight ,  nRotEx , nResca


 ? "Initialise"

FreeImage_Initialise(.t.)

 ? "Version          :", freeImage_GetVersion()
 ? "Copyright        :", freeImage_GetCopyrightMessage()
 ? "File type        :", freeImage_GetFileType( "proglogo.jpg" )

 nDll := freeImage_Load( FREE_IMAGE_FORMAT.FIF_JPEG, "proglogo.jpg", JPEG_DEFAULT )

 ? "Load JPEG        :", nDll

  nClone := freeImage_Clone( nDll )
  ? "Clone image     :" , nClone

  ? "Image Type       :", freeImage_GetImageType( nDll )
  ? "Color Used       :", freeImage_GetColorsUsed( nDll )
  ? "Pixel size       :", freeImage_GetBPP( nDll )
  ? "Width            :", freeImage_GetWidth( nDll)
  ? "Height           :", freeImage_GetHeight( nDll )
  ? "Byte Size        :", freeImage_GetLine( nDll )
  ? "Pitch            :", freeImage_GetPitch( nDll )
  ? "DIB Size         :", freeImage_GetDIBSize(nDll)
  ? "Dots per Meter X :", freeImage_GetDotsPerMeterX( nDll )
  ? "Dots per Meter Y :", freeImage_GetDotsPerMeterY( nDll )
  ? "Color Type       :", freeImage_GetColorType( nDll )
  ? "Red Mask         :", freeImage_GetRedMask( nDll )
  ? "Green Mask       :", freeImage_GetGreenMask( nDll )
  ? "Blue Mask        :", freeImage_GetBlueMask( nDll )
  ? "Transp. Count    :", freeImage_GetTransparencyCount( nDll )
  ? "Is Transparent ? :", freeImage_IsTransparent( nDll )

  ?
  ? "Save BMP ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_BMP, nDll, "proglogo.bmp", BMP_DEFAULT  )
  ? "Save JPG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_JPEG, nDll, "proglogo.jpg", JPEG_DEFAULT )
  ? "Save PNG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_PNG , nDll, "proglogo.png", PNG_DEFAULT  )

  ? "Save PNG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_PNG , nDll, "proglogo.png", PNG_DEFAULT  )
  ? "Save TIFF ?      :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_TIFF , nClone, "proglogo.tif", TIFF_DEFAULT )
  ? "Flip Horizontal ?:", freeImage_FlipHorizontal( nClone )
  ? "Save JPG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_JPEG, nClone,  "horizontal.jpg", JPEG_DEFAULT )
  ? "Flip Vertical ?  :", freeImage_FlipVertical( nClone )
  ? "Save JPG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_JPEG, nClone,  "vertical.jpg", JPEG_DEFAULT )

  ? "Rotate Classic   :", nRot := freeImage_RotateClassic( nClone, 90 )
  ? "Save JPG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_JPEG,  nRot, "rotate.jpg", JPEG_DEFAULT )
   freeImage_Unload( nRot )

   nCenterx := freeImage_GetWidth( nClone ) / 2
   nCentery := freeImage_GetHeight( nClone ) / 2

   ? "Rotate Ex        :", nRotEx := freeImage_RotateEx( nClone, 15, 0, 0, nCenterx, nCentery, .T.  )
   ? "Save JPG ?       :", freeImage_Save( FREE_IMAGE_FORMAT.FIF_JPEG, nRotEx,  "rotateEx.jpg", JPEG_DEFAULT )

   freeImage_Unload( nRotEx )


   nWidth   := freeImage_GetWidth(nDll)
   nHeight  := freeImage_GetHeight( nDll )


   ? "Rescale          :", nResca := freeImage_Rescale(nDll, nWidth / 2, nHeight / 2, FILTER_BICUBIC )
   ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nResca,  "rescale.jpg", JPEG_DEFAULT )
   freeImage_Unload( nResca )


   nD1 := freeImage_Clone( nDll )
   ? "Adjust Gamma ?   :", freeImage_AdjustGamma( nD1, 3.0 )
   ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "adjgamma.jpg", JPEG_DEFAULT )
   freeImage_Unload( nD1 )

   nD1 := freeImage_Clone( nDll)
   ? "Adjust Brightness:", freeImage_AdjustBrightness( nD1, -30 )
   ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "adjbright.jpg", JPEG_DEFAULT )
   freeImage_Unload( nD1 )

  nD1 := freeImage_Clone( nDll )
  ? "Adjust Contrast ?:", freeImage_AdjustContrast( nD1, -30 )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "adjcontrast.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )

  nD1 := freeImage_Clone( nDll )
  ? "Invert ?         :", freeImage_Invert( nD1 )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "invert.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )

  ? "Red Channel      :", nD1 := freeImage_GetChannel( nDll, FICC_RED )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "red.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )

  ? "Green Channel    :", nD1 := freeImage_GetChannel( nDll, FICC_GREEN )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT. FIF_JPEG, nD1, "green.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )

  ? "Blue Channel     :", nD1 := freeImage_GetChannel( nDll, FICC_BLUE )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1,  "blue.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )

  ? "Copy             :", nD1 := freeImage_Copy( nDll, 300, 100, 800, 200 )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD1, "copy.jpg", JPEG_DEFAULT )

  nD2 := freeImage_clone( nDll )
  ? "Paste ?          :", freeImage_Paste( nD2, nD1, 10, 10, 70 )
  ? "Save JPG ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_JPEG, nD2, "paste.jpg", JPEG_DEFAULT )
  freeImage_Unload( nD1 )
  freeImage_Unload( nD2 )

  ? "Allocate Bitmap  :", nD2 := freeImage_AllocateT(FREE_IMAGE_TYPE.FIT_BITMAP, 320, 200, 32 )
  ? 'alocate alocate' , nD2
  ? "Save JPG ?       :", freeImage_Save( 0, nD2, "allocate.jpg", 0 )
  freeImage_Unload( nD2 )

  ? "Create ERROR     :"
  ? "Save GIF ?       :", freeImage_Save(FREE_IMAGE_FORMAT.FIF_GIF, nDll, "wrong.gif", 0 )

  ? "Unload images from memory"
  freeImage_Unload( nDll )
  freeImage_Unload( nClone )

 ? "DeInitialise"
 FreeImage_DeInitialize( )

Sleep(600)

return nil

/*
   ? "Allocate Bitmap  :", nD2 := freeImage_AllocateT(FREE_IMAGE_TYPE.FIT_BITMAP, 320, 200, 32 )

  ? "Save JPG ?       :", freeImage_Save(0, nD2, "allocate.bmp", 0 )
*/
